/[MITgcm]/MITgcm/verification/testreport
ViewVC logotype

Diff of /MITgcm/verification/testreport

Parent Directory Parent Directory | Revision Log Revision Log | View Revision Graph Revision Graph | View Patch Patch

revision 1.163 by jmc, Wed May 18 22:03:57 2011 UTC revision 1.195 by jmc, Sun Sep 22 23:35:56 2013 UTC
# Line 11  usage() Line 11  usage()
11      echo      echo
12      echo "where possible OPTIONS are:"      echo "where possible OPTIONS are:"
13      echo "  (-help|-h)               print usage"      echo "  (-help|-h)               print usage"
14        echo " ---- type of test : ----"
15        echo "  (-tlm)                   perform a Tangent Linear run"
16        echo "  (-adm|-ad)               perform an adjoint run"
17        echo "  (-oad)                   perform an OpenAD adjoint run"
18      echo "  (-mth)                   run multi-threaded (using eedata.mth)"      echo "  (-mth)                   run multi-threaded (using eedata.mth)"
19      echo "  (-mpi)                   use MPI to compile and run on 2 processors"      echo "  (-mpi)                   use MPI to compile and run on 2 processors"
20      echo "  (-MPI)  NUMBER           use MPI to compile and run on max NUMBER procs"      echo "  (-MPI)  NUMBER           use MPI to compile and run on max NUMBER procs"
21      echo "  (-mfile|-mf) STRING      MPI: file with list of possible machines to run on"      echo "  (-mfile|-mf) STRING      MPI: file with list of possible machines to run on"
22      echo "  (-ieee/-noieee)          if possible, use IEEE compiler flags"      echo "  (-command|-c) STRING     command to run (e.g., if non-standard MPI setting)"
23      echo "                             (DEF=\"-ieee\")"      echo "                            DEF='mitgcmuv' or ='mpirun -np TR_NPROC mitgcmuv'"
24        echo " ---- testing options : ----"
25        echo "  (-optfile|-of) STRING    list of optfiles to use"
26        echo "  (-fast)                  use optfile default for compiler flags (no '-ieee')"
27        echo "                            DEF=off => use IEEE numerics option (if available)"
28        echo "  (-devel)                 use optfile developement flags (if available)"
29      echo "  (-gsl)                   compile with \"-gsl\" flag"      echo "  (-gsl)                   compile with \"-gsl\" flag"
30      echo "  (-use_r4|-ur4)           if allowed, use real*4 type for '_RS' variable"      echo "  (-use_r4|-ur4)           if allowed, use real*4 type for '_RS' variable"
     echo "  (-optfile|-of) STRING    list of optfiles to use"  
     echo "  (-addr|-a) STRING        list of email recipients"  
     echo "                             (DEF=\"\" no email is sent)"  
     echo "  (-mpackdir|-mpd) DIR     location of the mpack utility"  
     echo "                             (DEF=\"../tools/mpack-1.6\")"  
31      echo "  (-tdir|-t) STRING        list of group and/or exp. dirs to test"      echo "  (-tdir|-t) STRING        list of group and/or exp. dirs to test"
32      echo "                             (recognized groups: basic, tutorials)"      echo "                             (recognized groups: basic, tutorials)"
33      echo "                             (DEF=\"\" which test all)"      echo "                             (DEF=\"\" which test all)"
# Line 31  usage() Line 35  usage()
35      echo "                              test THIS_EXP + all the following)"      echo "                              test THIS_EXP + all the following)"
36      echo "  (-skipdir|-skd) STRING   list of exp. dirs to skip"      echo "  (-skipdir|-skd) STRING   list of exp. dirs to skip"
37      echo "                             (DEF=\"\" which test all)"      echo "                             (DEF=\"\" which test all)"
38      echo "  (-bash|-b) STRING        preferred location of a \"bash\" or"      echo "  (-ts)                    provide timing information per timestep"
39      echo "                             Bourne-compatible \"sh\" shell"      echo "  (-papis)                 provide MFlop/s per timestep using PAPI"
40        echo "  (-pcls)                  provide MFlop/s per timestep using PCL"
41        echo " ---- system options : ----"
42        echo "  (-bash|-b) STRING        preferred location of a \"bash\" or \"sh\" shell"
43      echo "                             (DEF=\"\" for \"bash\")"      echo "                             (DEF=\"\" for \"bash\")"
44      echo "  (-adm|-ad)               perform an adjoint run"      echo "  (-ef) STRING             used as genmake2 \"-extra_flag\" argument"
     echo "  (-oad)                   perform an OpenAD adjoint run"  
     echo "  (-command|-c) STRING     command to run"  
45      echo "  (-makedepend|-md) STRING command to use for \"makedepend\""      echo "  (-makedepend|-md) STRING command to use for \"makedepend\""
46      echo "  (-make|-m) STRING        command to use for \"make\""      echo "  (-make|-m) STRING        command to use for \"make\""
47      echo "                             (DEF=\"make\")"      echo "                             (DEF=\"make\")"
48      echo "  (-odir) STRING           used to build output directory name"      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"
49      echo "                             (DEF=\"hostname\")"      echo " ---- output options : ----"
 #   echo "  (-ptracers|-ptr) STRING  specify which ptracers to test"  
 #   echo "                             (DEF=\"1 2 3 4 5\")"  
50      echo "  (-match) NUMBER          Matching Criteria (number of digits)"      echo "  (-match) NUMBER          Matching Criteria (number of digits)"
51      echo "                             (DEF=\"$MATCH_CRIT\")"      echo "                             (DEF=\"$MATCH_CRIT\")"
52      echo "  (-j) JOBS                use \"make -j JOBS\" for parallel builds"      echo "  (-odir) STRING           used to build output directory name"
53        echo "                             (DEF=\"hostname\")"
54        echo "  (-addr|-a) STRING        list of email recipients"
55        echo "                             (DEF=\"\" no email is sent)"
56        echo "  (-send)       STRING     sending command (instead of using mpack)"
57        echo "  (-savdir|-sd) STRING     location to save output tar file to send (DEF='$SAVDIR')"
58        echo "  (-mpackdir|-mpd) DIR     location of the mpack utility"
59        echo "                             (DEF=\"../tools/mpack-1.6\")"
60        echo " -- do only some parts: --"
61      echo "  (-clean)                 *ONLY* run \"make CLEAN\" & clean run-dir"      echo "  (-clean)                 *ONLY* run \"make CLEAN\" & clean run-dir"
62      echo "  (-norun|-nr)             skip the \"runmodel\" stage (stop after make)"      echo "  (-norun|-nr)             skip the \"runmodel\" stage (stop after make)"
63        echo "  (-obj)                   only produces objects (=norun & no executable)"
64      echo "  (-runonly|-ro)           *ONLY* run stage (=\"-quick\" without make)"      echo "  (-runonly|-ro)           *ONLY* run stage (=\"-quick\" without make)"
65      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""      echo "  (-quick|-q)              same as \"-nogenmake -noclean -nodepend\""
66      echo "  (-nogenmake|-ng)         skip the genmake stage"      echo "  (-nogenmake|-ng)         skip the genmake stage"
# Line 57  usage() Line 69  usage()
69      echo "  (-postclean|-pc)         after each exp. test, clean build-dir & run-dir"      echo "  (-postclean|-pc)         after each exp. test, clean build-dir & run-dir"
70      echo "  (-deloutp|-do)           delete output files after successful run"      echo "  (-deloutp|-do)           delete output files after successful run"
71      echo "  (-deldir|-dd)            on success, delete the output directory"      echo "  (-deldir|-dd)            on success, delete the output directory"
     echo "  (-ts)                    provide timing information per timestep"  
     echo "  (-papis)                 provide MFlop/s per timestep using PAPI"  
     echo "  (-pcls)                  provide MFlop/s per timestep using PCL"  
72      echo      echo
73      echo "and where STRING can be a whitespace-delimited list"      echo "and where STRING can be a whitespace-delimited list"
74      echo "such as:"      echo "such as:"
# Line 114  testoutput_var() Line 123  testoutput_var()
123      # testoutput_var dir s1 label subdir reference_output      # testoutput_var dir s1 label subdir reference_output
124      #      #
125      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE      #  compares 1 variable output selected from file $dir/$subdir/$OUTPUTFILE
126      #     with same output from reference file $dir/results/$reference_output      #     with same output from reference file $dir/$reference_output
127      #  using search strings s1 and text label      #  using search strings s1 and text label
128    
129      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
130          echo testoutput_var: grep "$2" $1/$4/$OUTPUTFILE 1>&2          echo testoutput_var: grep "$2" $1/$4/$OUTPUTFILE 1>&2
131      fi      fi
132      if [ -r $1/$4/$OUTPUTFILE ]; then      if [ -r $1/$4/$OUTPUTFILE ]; then
133          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > tmp1.txt          grep "$2" $1/$4/$OUTPUTFILE | sed 's/.*=//' | cat -n > ${TMP}a.txt
134          lncntA=`wc -l tmp1.txt | awk '{print $1}' `          lncntA=`wc -l ${TMP}a.txt | awk '{print $1}' `
135          if [ $lncntA -lt 2 ]; then          if [ $lncntA -lt 2 ]; then
136              if [ $verbose -gt 0 ]; then              if [ $verbose -gt 0 ]; then
137                  echo Not enough lines of output when searching for "$2" 1>&2                  echo Not enough lines of output when searching for "$2" 1>&2
138              fi              fi
139              return 99              rm -f ${TMP}a.txt ; return 99
140          fi          fi
141      else      else
142          echo testoutput_var: $OUTPUTFILE from model run was not readable 1>&2          echo testoutput_var: $OUTPUTFILE from model run was not readable 1>&2
143          return 99          return 99
144      fi      fi
145      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
146          echo testoutput_var: grep "$2" $1/results/$5 1>&2          echo testoutput_var: grep "$2" $1/$5 1>&2
147      fi      fi
148      grep "$2" $1/results/$5 | sed 's/.*=//' | cat -n > tmp2.txt      grep "$2" $1/$5 | sed 's/.*=//' | cat -n > ${TMP}b.txt
149      lncntB=`wc -l tmp2.txt | awk '{print $1}' `      lncntB=`wc -l ${TMP}b.txt | awk '{print $1}' `
150      if [ $lncntB -lt 2 ]; then      if [ $lncntB -lt 2 ]; then
151          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
152              echo Not enough lines of output when searching for "$2" 1>&2              echo Not enough lines of output when searching for "$2" 1>&2
153          fi          fi
154          return 99          rm -f ${TMP}a.txt ${TMP}b.txt ; return 99
155      fi      fi
156      if [ $lncntA -ne $lncntB ]; then      if [ $lncntA -ne $lncntB ]; then
157          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
158              echo Not same Nb of lines when searching for "$2" ":" $lncntA $lncntB 1>&2              echo Not same Nb of lines when searching for "$2" ":" $lncntA $lncntB 1>&2
159          fi          fi
160          return 99          rm -f ${TMP}a.txt ${TMP}b.txt ; return 99
161      fi      fi
162      has_nan=`cat tmp1.txt | grep -i nan | wc -l`      has_nan=`cat ${TMP}a.txt | grep -i nan | wc -l`
163      if [ $has_nan -gt 0  ] ; then      if [ $has_nan -gt 0  ] ; then
164          echo testoutput_var: $OUTPUTFILE contains $has_nan NaN values  1>&2          echo testoutput_var: $OUTPUTFILE contains $has_nan NaN values  1>&2
165          return 99          rm -f ${TMP}a.txt ${TMP}b.txt ; return 99
166      fi      fi
167      has_inf=`cat tmp1.txt | grep -i inf | wc -l`      has_inf=`cat ${TMP}a.txt | grep -i inf | wc -l`
168      if [ $has_inf -gt 0  ] ; then      if [ $has_inf -gt 0  ] ; then
169          echo testoutput_var: $OUTPUTFILE contains $has_inf Inf values  1>&2          echo testoutput_var: $OUTPUTFILE contains $has_inf Inf values  1>&2
170          return 99          rm -f ${TMP}a.txt ${TMP}b.txt ; return 99
171      fi      fi
172      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
173          echo testoutput_var: join tmp1.txt tmp2.txt 1>&2          echo testoutput_var: join ${TMP}a.txt ${TMP}b.txt 1>&2
174      fi      fi
175      join tmp1.txt tmp2.txt | awk '{print $1 " " $2 " " $3}' > tmp3.txt      # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number
176        join ${TMP}a.txt ${TMP}b.txt | awk '{print $1 " " $2 " " $3}' | sed -e 's|:||g' > ${TMP}c.txt
177      if [ $debug -gt 0 ]; then      if [ $debug -gt 0 ]; then
178          echo testoutput_var: compare_lines 1>&2          echo testoutput_var: compare_lines 1>&2
179      fi      fi
180      if [ $verbose -gt 1 ]; then      if [ $verbose -gt 1 ]; then
181          cat tmp3.txt 1>&2          cat ${TMP}c.txt 1>&2
182      fi      fi
183      echo "-1" >> tmp3.txt      echo "-1" >> ${TMP}c.txt
184      # On the SGI O3K (*not* the O2K), "cat -n" inserts a ":" after the line number      digits_of_similarity=`./tr_cmpnum < ${TMP}c.txt`
     cat tmp3.txt | sed -e 's|:||g' > tmp4.txt  
     digits_of_similarity=`./tr_cmpnum < tmp4.txt`  
185      if [ $digits_of_similarity -eq 99 ]; then      if [ $digits_of_similarity -eq 99 ]; then
186          if [ $verbose -gt 0 ]; then          if [ $verbose -gt 0 ]; then
187              echo testoutput_var: No comparison was available for \"$3\" 1>&2              echo testoutput_var: No comparison was available for \"$3\" 1>&2
# Line 184  testoutput_var() Line 192  testoutput_var()
192              echo There were $digits_of_similarity decimal places of similarity for \"$3\" 1>&2              echo There were $digits_of_similarity decimal places of similarity for \"$3\" 1>&2
193          fi          fi
194      fi      fi
195      rm -f tmp1.txt tmp2.txt tmp3.txt tmp4.txt      rm -f ${TMP}a.txt ${TMP}b.txt ${TMP}c.txt
196    
197      return $digits_of_similarity      return $digits_of_similarity
198  }  }
# Line 195  testoutput_run() Line 203  testoutput_run()
203      #      #
204      #  test output from 1 run in "directory"      #  test output from 1 run in "directory"
205  # --> same processing for adjoint & forward test  # --> same processing for adjoint & forward test
206          # default list of output variables to be checked:          # default list of output variables to be checked:
207          #  1rst : main variable used to decide if it pass or FAIL          #  1rst : main variable used to decide if it pass or FAIL
208          #  others : number of matching digits to be printed in summary.txt          #  others : number of matching digits to be printed in summary.txt
209          listChk=$DEF_CHECK_LIST          listChk=$DEF_CHECK_LIST
210          #  load experiment-specific list from file "tr_checklist" (if it exist)          #  load experiment-specific list from file "tr_checklist" (if it exist)
211          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi          if test -r $1/$2/tr_checklist ; then listChk=`cat $1/$2/tr_checklist` ; fi
212          sVar=`echo $listChk | awk '{print $1}'`          sVar=`echo $listChk | awk '{print $1}'`
213          # remove 1rst var and expand the list: + => min max mean s.d          # remove 1rst var and expand the list: + => min max mean s.d
214          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \          listVar=`echo $listChk | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' \
215                                 | sed 's/+//g' | sed "s/^$sVar//"`                                 | sed 's/+//g' | sed "s/^$sVar//"`
216          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(I)='$listVar'" 1>&2 ; fi
217          # check for ptracer output in reference_output file :          # set ref.outp file-name and, if compressed, uncompress it into subdir
218          outpref=$1/results/$3          refoutp=results/$3
219          ptr_mon="trcstat_ptracerXX_min trcstat_ptracerXX_max"          if test ! -r $1/results/$3 ; then
220          ptr_mon="$ptr_mon trcstat_ptracerXX_mean trcstat_ptracerXX_sd"            if test -r $1/results/${3}.gz ; then
221          for ii in $PTRACERS_NUM ; do              tmpNam1=$3
222                tmpNam2=`echo $tmpNam1 | sed 's/\..*\././'`
223                if test "x$tmpNam1" = "x$tmpNam2" ; then
224                    tmpNam1=`echo $tmpNam2 | sed 's/\./.std./'`
225                fi
226                refoutp=$2/$tmpNam1
227                if [ $debug -gt 0 ]; then
228                    echo "testoutput_run: gunzip 'results/$3.gz' into '$refoutp'" 1>&2
229                fi
230                gzip -cd $1/results/${3}.gz > $1/$refoutp
231              else
232                echo "missing reference output file '$3' (.gz) in '$1/results/'"
233              fi
234            fi
235            # check for ptracer output in reference_output file :
236            if test $KIND = 0 ; then
237              ptr_mon="trcstat_ptracerXX_min trcstat_ptracerXX_max"
238              ptr_mon="$ptr_mon trcstat_ptracerXX_mean trcstat_ptracerXX_sd"
239              for ii in $PTRACERS_NUM ; do
240              ptrfound=0              ptrfound=0
241              for jj in $ptr_mon ; do              for jj in $ptr_mon ; do
242                  name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`                  name=`eval "echo $jj | sed -e 's|XX|0"$ii"|g'"`
243                  tst=`grep $name $outpref | wc -l | awk '{print $1}'`                  tst=`grep $name $1/$refoutp | wc -l | awk '{print $1}'`
244                  if test ! "x$tst" = x0 ; then ptrfound=1 ; fi                  if test ! "x$tst" = x0 ; then ptrfound=1 ; fi
245              done              done
246              if test $ptrfound = '1' ; then              if test $ptrfound = '1' ; then
247                  eval "HAVE_PTR0"$ii"=t"                  eval "HAVE_PTR0"$ii"=t"
248              else              else
249                  eval "HAVE_PTR0"$ii"=f"                  eval "HAVE_PTR0"$ii"=f"
               if test "x$ADM" = x -a "x$OADM" = x; then  
250                # remove this ptr from the list of output variable to check                # remove this ptr from the list of output variable to check
251                # echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2                # echo "-- ptr test=" $tst "number of var=" `echo $listVar | awk '{print NF}'` 1>&2
252                  listVar=`echo "$listVar" | sed "s/ pt$ii..//g"`                  listVar=`echo "$listVar" | sed "s/ pt$ii..//g"`
               fi  
253              fi              fi
254          #   eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"' 1>&2            # eval 'echo "HAVE_PTR0'$ii' = $HAVE_PTR0'$ii'"' 1>&2
255          done            done
256          tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){if($i==$1)t+=1}; print t }'`          fi
257          if test $tst != 1 ; then          tst=`echo $sVar $listVar | awk '{ for(i=2;i<=NF;i++){if($i==$1)t+=1}; print t }'`
258            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2          if test $tst != 1 ; then
259                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi            if test $tst = 0 ; then echo "==> WARNING: selected var >$sVar< not found" 1>&2
260            echo "==> WARNING: in checked list:" $listVar 1>&2                   else echo "==> WARNING: found selected var >$sVar< $tst times" 1>&2 ; fi
261          #- put it back once:            echo "==> WARNING: in checked list:" $listVar 1>&2
262            listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`          #- put it back once:
263          fi            listVar=" $sVar "`echo "$listVar " | sed "s/ $sVar / /g"`
264            fi
265          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi          if [ $debug -gt 0 ]; then echo "testoutput_run: listVar(M)='$listVar'" 1>&2 ; fi
266          echo "listVar='$listVar'" >> $locDIR"/summary.txt"          echo "listVar='$listVar'" >> $locDIR"/summary.txt"
267          #---          #---
268          allargs=""          allargs=""
269          for xx in $listVar          for xx in $listVar
270          do          do
271            case $xx in            case $xx in
272             'PS')  if [ $debug -gt 0 ]             'PS')  if [ $debug -gt 0 ]
273                    then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi                    then echo testoutput_run: testoutput_var $1 cg2d_init_res 1>&2 ; fi
274                    testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $3; yy=$?                    testoutput_var $1 "cg2d_init_res" "Press. Solver (cg2d)" $2 $refoutp ; yy=$?
275                    if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;                    if [ $debug -gt 0 ] ; then echo testoutput_run: cg2dres=$yy 1>&2 ; fi ;;
276            'Cost') testoutput_var $1 "ADM  precision_derivative_cost" "ADM Cost" $2 $3; yy=$? ;;            'Cost') testoutput_var $1 "ADM  ref_cost_function" "ADM CostFct" $2 $refoutp ; yy=$? ;;
277            'Grad') testoutput_var $1 "ADM  precision_derivative_grad" "ADM Grad" $2 $3; yy=$? ;;           'AdGrd') testoutput_var $1 "ADM  adjoint_gradient"  "ADM Ad Grad" $2 $refoutp ; yy=$? ;;
278             'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $3; yy=$? ;;           'FDGrd') testoutput_var $1 "ADM  finite-diff_grad"  "ADM FD Grad" $2 $refoutp ; yy=$? ;;
279             'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $3; yy=$? ;;          'tlmCst') testoutput_var $1 "TLM  ref_cost_function" "TLM CostFct" $2 $refoutp ; yy=$? ;;
280             'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $3; yy=$? ;;          'tlmGrd') testoutput_var $1 "TLM  tangent-lin_grad"  "TLM TL Grad" $2 $refoutp ; yy=$? ;;
281             'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $3; yy=$? ;;          'fwdGrd') testoutput_var $1 "TLM  finite-diff_grad"  "TLM FD Grad" $2 $refoutp ; yy=$? ;;
282             'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $3; yy=$? ;;             'Tmn') testoutput_var $1 "dynstat_theta_min"  "Theta minimum"  $2 $refoutp ; yy=$? ;;
283             'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $3; yy=$? ;;             'Tmx') testoutput_var $1 "dynstat_theta_max"  "Theta maximum"  $2 $refoutp ; yy=$? ;;
284             'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $3; yy=$? ;;             'Tav') testoutput_var $1 "dynstat_theta_mean" "Theta mean"     $2 $refoutp ; yy=$? ;;
285             'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $3; yy=$? ;;             'Tsd') testoutput_var $1 "dynstat_theta_sd"   "Theta Std.Dev"  $2 $refoutp ; yy=$? ;;
286             'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $3; yy=$? ;;             'Smn') testoutput_var $1 "dynstat_salt_min"  "Salt minimum"    $2 $refoutp ; yy=$? ;;
287             'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $3; yy=$? ;;             'Smx') testoutput_var $1 "dynstat_salt_max"  "Salt maximum"    $2 $refoutp ; yy=$? ;;
288             'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $3; yy=$? ;;             'Sav') testoutput_var $1 "dynstat_salt_mean" "Salt mean"       $2 $refoutp ; yy=$? ;;
289             'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $3; yy=$? ;;             'Ssd') testoutput_var $1 "dynstat_salt_sd"   "Salt Std.Dev"    $2 $refoutp ; yy=$? ;;
290             'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $3; yy=$? ;;             'Umn') testoutput_var $1 "dynstat_uvel_min"  "U minimum"       $2 $refoutp ; yy=$? ;;
291             'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $3; yy=$? ;;             'Umx') testoutput_var $1 "dynstat_uvel_max"  "U maximum"       $2 $refoutp ; yy=$? ;;
292             'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $3; yy=$? ;;             'Uav') testoutput_var $1 "dynstat_uvel_mean" "U mean"          $2 $refoutp ; yy=$? ;;
293             'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $3; yy=$? ;;             'Usd') testoutput_var $1 "dynstat_uvel_sd"   "U Std.Dev"       $2 $refoutp ; yy=$? ;;
294               'Vmn') testoutput_var $1 "dynstat_vvel_min"  "V minimum"       $2 $refoutp ; yy=$? ;;
295               'Vmx') testoutput_var $1 "dynstat_vvel_max"  "V maximum"       $2 $refoutp ; yy=$? ;;
296               'Vav') testoutput_var $1 "dynstat_vvel_mean" "V mean"          $2 $refoutp ; yy=$? ;;
297               'Vsd') testoutput_var $1 "dynstat_vvel_sd"   "V Std.Dev"       $2 $refoutp ; yy=$? ;;
298          'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1mn'|'pt2mn'|'pt3mn'|'pt4mn'|'pt5mn') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
299             testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_min"  "p0"$ii"_min"   $2 $refoutp ; yy=$? ;;
300          'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1mx'|'pt2mx'|'pt3mx'|'pt4mx'|'pt5mx') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
301             testoutput_var $1 "trcstat_ptracer0"$ii"_max"  "p0"$ii"_max"   $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_max"  "p0"$ii"_max"   $2 $refoutp ; yy=$? ;;
302          'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1av'|'pt2av'|'pt3av'|'pt4av'|'pt5av') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
303             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_mean" "p0"$ii"_mean" $2 $refoutp ; yy=$? ;;
304          'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`          'pt1sd'|'pt2sd'|'pt3sd'|'pt4sd'|'pt5sd') ii=`echo $xx | sed 's/pt//' | sed 's/..$//'`
305             testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $3; yy=$? ;;             testoutput_var $1 "trcstat_ptracer0"$ii"_sd"   "p0"$ii"_StDv"  $2 $refoutp ; yy=$? ;;
306           'Qntmn') testoutput_var $1 "forcing_qnet_min" "Qnet minimum"  $2 $3; yy=$? ;;           'Qntmn') testoutput_var $1 "forcing_qnet_min" "Qnet minimum"  $2 $refoutp ; yy=$? ;;
307           'Qntmx') testoutput_var $1 "forcing_qnet_max" "Qnet maximum"  $2 $3; yy=$? ;;           'Qntmx') testoutput_var $1 "forcing_qnet_max" "Qnet maximum"  $2 $refoutp ; yy=$? ;;
308           'Qntav') testoutput_var $1 "forcing_qnet_mean" "Qnet mean"       $2 $3; yy=$? ;;           'Qntav') testoutput_var $1 "forcing_qnet_mean" "Qnet mean"       $2 $refoutp ; yy=$? ;;
309           'Qntsd') testoutput_var $1 "forcing_qnet_sd"  "Qnet Std.Dev"  $2 $3; yy=$? ;;           'Qntsd') testoutput_var $1 "forcing_qnet_sd"  "Qnet Std.Dev"  $2 $refoutp ; yy=$? ;;
310           'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $3; yy=$? ;;           'aSImn') testoutput_var $1 "seaice_area_min"   "SIce Area min"   $2 $refoutp ; yy=$? ;;
311           'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $3; yy=$? ;;           'aSImx') testoutput_var $1 "seaice_area_max"   "SIce Area max"   $2 $refoutp ; yy=$? ;;
312           'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $3; yy=$? ;;           'aSIav') testoutput_var $1 "seaice_area_mean"  "SIce Area mean"  $2 $refoutp ; yy=$? ;;
313           'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $3; yy=$? ;;           'aSIsd') testoutput_var $1 "seaice_area_sd"    "SIce Area StDv"  $2 $refoutp ; yy=$? ;;
314           'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $3; yy=$? ;;           'hSImn') testoutput_var $1 "seaice_heff_min"   "SIce Heff min"   $2 $refoutp ; yy=$? ;;
315           'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Heff max"   $2 $3; yy=$? ;;           'hSImx') testoutput_var $1 "seaice_heff_max"   "SIce Heff max"   $2 $refoutp ; yy=$? ;;
316           'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Heff mean"  $2 $3; yy=$? ;;           'hSIav') testoutput_var $1 "seaice_heff_mean"  "SIce Heff mean"  $2 $refoutp ; yy=$? ;;
317           'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Heff StDv"  $2 $3; yy=$? ;;           'hSIsd') testoutput_var $1 "seaice_heff_sd"    "SIce Heff StDv"  $2 $refoutp ; yy=$? ;;
318          'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $3; yy=$? ;;           'uSImn') testoutput_var $1 "seaice_uice_min"   "SIce Uice min"   $2 $refoutp ; yy=$? ;;
319          'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $3; yy=$? ;;           'uSImx') testoutput_var $1 "seaice_uice_max"   "SIce Uice max"   $2 $refoutp ; yy=$? ;;
320          'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $3; yy=$? ;;           'uSIav') testoutput_var $1 "seaice_uice_mean"  "SIce Uice mean"  $2 $refoutp ; yy=$? ;;
321          'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Global"    $2 $3; yy=$? ;;           'uSIsd') testoutput_var $1 "seaice_uice_sd"    "SIce Uice StDv"  $2 $refoutp ; yy=$? ;;
322          'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South"     $2 $3; yy=$? ;;           'vSImn') testoutput_var $1 "seaice_vice_min"   "SIce Vice min"   $2 $refoutp ; yy=$? ;;
323          'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North"     $2 $3; yy=$? ;;           'vSImx') testoutput_var $1 "seaice_vice_max"   "SIce Vice max"   $2 $refoutp ; yy=$? ;;
324                *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;           'vSIav') testoutput_var $1 "seaice_vice_mean"  "SIce Vice mean"  $2 $refoutp ; yy=$? ;;
325            esac           'vSIsd') testoutput_var $1 "seaice_vice_sd"    "SIce Vice StDv"  $2 $refoutp ; yy=$? ;;
326            if test $xx = $sVar          'AthSiG') testoutput_var $1 "thSI_Ice_Area_G" "thSIc Area Global" $2 $refoutp ; yy=$? ;;
327            then allargs="$allargs > $yy <"          'AthSiS') testoutput_var $1 "thSI_Ice_Area_S" "thSIc Area South"  $2 $refoutp ; yy=$? ;;
328            else allargs="$allargs $yy"          'AthSiN') testoutput_var $1 "thSI_Ice_Area_N" "thSIc Area North"  $2 $refoutp ; yy=$? ;;
329            fi          'HthSiG') testoutput_var $1 "thSI_IceH_ave_G" "thSIc H Glob-ave"  $2 $refoutp ; yy=$? ;;
330          done          'HthSiS') testoutput_var $1 "thSI_IceH_ave_S" "thSIc H South-av"  $2 $refoutp ; yy=$? ;;
331            'HthSiN') testoutput_var $1 "thSI_IceH_ave_N" "thSIc H North-av"  $2 $refoutp ; yy=$? ;;
332            'HthMxS') testoutput_var $1 "thSI_IceH_max_S" "thSIc H South-max" $2 $refoutp ; yy=$? ;;
333            'HthMxN') testoutput_var $1 "thSI_IceH_max_N" "thSIc H North-max" $2 $refoutp ; yy=$? ;;
334            'StrmIc') testoutput_var $1 "STREAMICE_FP_ERR" "StreamIce Solver" $2 $refoutp ; yy=$? ;;
335                  *) yy=99; echo "WARNING: asking for var=$xx : not recognized !" 1>&2 ;;
336              esac
337              if test $xx = $sVar
338              then allargs="$allargs > $yy <"
339              else allargs="$allargs $yy"
340              fi
341            done
342    
343          nbVar=`echo $listVar | awk '{print NF}'`          nbVar=`echo $listVar | awk '{print NF}'`
344          if [ $nbVar -lt $LEN_CHECK_LIST ] ; then          if [ $nbVar -lt $LEN_CHECK_LIST ] ; then
345          #-- fill line (up to standard length) with dot:          #-- fill line (up to standard length) with dot:
346            adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`            adNul=`expr $LEN_CHECK_LIST - $nbVar | awk '{for(i=1;i<=$1;i++){print "."}}'`
347            echo $allargs $adNul            echo $allargs $adNul
348          else          else
349            echo $allargs            echo $allargs
350          fi          fi
351  # <-- same processing for adjoint & forward test  # <-- same processing for adjoint & forward test
# Line 328  genmakemodel() Line 368  genmakemodel()
368              if test "x$MKDEPEND" != x ; then              if test "x$MKDEPEND" != x ; then
369                  command="$command -makedepend=$MKDEPEND"                  command="$command -makedepend=$MKDEPEND"
370              fi              fi
371              if test "x$ADM" = xt ; then              if test $KIND = 1 -o $KIND = 2 ; then
372                  command="$command --mods=../code_ad"                  command="$command --mods=../code_ad"
373              elif test "x$OADM" = xt ; then              elif test $KIND = 4 ; then
374                  command="$command -adof ../../../tools/adjoint_options/adjoint_oad -mods '../code_oad ../../OpenAD/code_oad_all'"                  command="$command -adof ../../../tools/adjoint_options/adjoint_oad -mods ../code_oad"
375              else              else
376                  command="$command -mods=../code"                  command="$command -mods=../code"
377              fi              fi
378              if test "x$OPTFILE" != xNONE ; then              if test "x$OPTFILE" != xNONE ; then
379                  command="$command -optfile=$OPTFILE"                  command="$command -optfile=$OPTFILE"
380              fi              fi
381              if test "x$IEEE" != x ; then              if test $OptLev = 1 ; then
382                  command="$command -ieee"                  command="$command -ieee"
383              fi              fi
384                if test $OptLev = 0 ; then
385                    command="$command -devel"
386                fi
387              if test "x$GSL" = xt ; then              if test "x$GSL" = xt ; then
388                  command="$command -gsl"                  command="$command -gsl"
389              fi              fi
# Line 354  genmakemodel() Line 397  genmakemodel()
397              if test "x$USE_R4" = xt ; then              if test "x$USE_R4" = xt ; then
398                  command="$command -use_r4"                  command="$command -use_r4"
399              fi              fi
400                if test "x$EXTRFLG" != x ; then
401                    command="$command -extra_flag $EXTRFLG"
402                fi
403              if test "x$TS" = xt ; then              if test "x$TS" = xt ; then
404                  command="$command -ts"                  command="$command -ts"
405              fi              fi
# Line 384  genmakemodel() Line 430  genmakemodel()
430  makeclean()  makeclean()
431  {  {
432      # makeclean directory      # makeclean directory
433      if test "x$NODEPEND" = xf ; then rm -f $1/make.tr_log ; fi      if test "x$NOGENMAKE" = xf ; then rm -f $1/make.tr_log ; fi
434      if test "x$NOCLEAN" = xt ; then      if test "x$NOCLEAN" = xt ; then
435          echo "make Clean skipped!"          echo "make Clean skipped!"
436      else      else
# Line 416  run_clean() Line 462  run_clean()
462      if test "x$NOCLEAN" = xt ; then      if test "x$NOCLEAN" = xt ; then
463          echo "run_clean skipped!"          echo "run_clean skipped!"
464      else      else
465          (        (
466              cd $1;          cd $1;
467              printf 'clean run-dir ... '          printf 'clean run-dir ... '
468              # part of what is done after "make clean" when doing "make CLEAN"          # part of what is done after "make clean" when doing "make CLEAN"
469              find . -name "*.meta" -exec rm {} \;          find . -name "*.meta" -exec rm {} \;
470              find . -name "*.data" -exec rm {} \;          find . -name "*.data" -exec rm {} \;
471              find . -name "fort.*" -exec rm {} \;          find . -name "fort.*" -exec rm {} \;
472              find . -type l -exec rm {} \;          find . -type l -exec rm {} \;
473              #- should remove executable only if sym-link (alredy done above)          #- should remove executable only if sym-link (already done above)
474              rm -f $RUNLOG *.txt STD* *diagnostics.log datetime          rm -f $RUNLOG *.txt STDOUT.* STDERR.* *diagnostics.log *.[0-9][0-9][0-9][0-9].log
475              rm -rf mnc_test_*          rm -f datetime costfinal divided.ctrl snapshot* output_adm.*.diva_*
476              rm -f *_MIT_CE_000.opt0000 costfunction*0000          rm -f *_MIT_CE_000.opt0000 costfunction*0000
477              echo successful          rm -f oad_cp.[0-9][0-9][0-9].?????
478              exit 0          rm -rf mnc_test_*
479          )          echo successful
480            exit 0
481          )
482      fi      fi
483  }  }
484    
# Line 474  makemodel() Line 522  makemodel()
522          cd $1;          cd $1;
523          if test -r Makefile ; then          if test -r Makefile ; then
524              printf 'make ... '              printf 'make ... '
525              if test "x$ADM" = xt ; then              if test "x$REPLMAKE" = x ; then
526                  $MAKE adall >> make.tr_log 2>&1                  $MAKE $TARG >> make.tr_log 2>&1
527              elif test "x$OADM" = xt ; then              else
528                  $MAKE adAll >> make.tr_log 2>&1                  $REPLMAKE $TARG >> make.tr_log 2>&1
             else  
                 if test "x$JOBS" = x ; then  
                     $MAKE >> make.tr_log 2>&1  
                 else  
                     $MAKE -j $JOBS >> make.tr_log 2>&1  
                 fi  
529              fi              fi
530              RETVAL=$?              RETVAL=$?
531              if test "x$RETVAL" != x0 ; then              if test "x$RETVAL" != x0 ; then
# Line 501  makemodel() Line 543  makemodel()
543              mk_fail=2              mk_fail=2
544          fi          fi
545      fi      fi
546      if test "x$ADM" = xt -a -f taf_ad.log ; then      if test $KIND = 1 -a -f taf_ftl.log ; then
547              head -1 taf_ad.log >> $CDIR"/summary.txt"          head -1 taf_ftl.log >> $CDIR"/summary.txt"
548              nerr=`grep -c 'TAF *.* ERROR ' taf_ad.log`      fi
549              nwar=`grep -c 'TAF RECOMPUTATION *.* WARNING ' taf_ad.log`      if test $KIND = 2 -a -f taf_ad.log ; then
550              echo " TAF reports $nerr Errors and $nwar Recomputation Warnings" \          head -1 taf_ad.log >> $CDIR"/summary.txt"
551            nerr=`grep -c 'TAF *.* ERROR ' taf_ad.log`
552            nwar=`grep -c 'TAF RECOMPUTATION *.* WARNING ' taf_ad.log`
553            if test -f taf_output ; then
554                n2er=`grep -c 'TAF *.* ERROR ' taf_output`
555                n3er=`grep -c '\*ERROR\* ' taf_output`
556                nerr=`expr $nerr + $n2er + $n3er`
557            fi
558            echo " TAF reports $nerr Errors and $nwar Recomputation Warnings" \
559                                  >> $CDIR"/summary.txt"                                  >> $CDIR"/summary.txt"
560      fi      fi
561      if test $mk_fail != 0 ; then return $mk_fail ; fi      if test $mk_fail != 0 ; then return $mk_fail ; fi
# Line 514  makemodel() Line 564  makemodel()
564    
565  mk_mpi_size()  mk_mpi_size()
566  {  {
567      # mk_mpi_size input_file output_file proc_Nb prefer_to_split_X      # mk_mpi_size input_file output_file proc_Nb threads_Nb_X threads_Nb_Y
568      #      #
569      # make new SIZE.h (=output_file) from SIZE.h_mpi (=input_file)      #  make new SIZE.h (=output_file) from SIZE.h_mpi (=input_file)
570      #     for an MPI build with no more than proc_Nb processors ;      #     for an MPI build with no more than proc_Nb processors ;
571      # return the effective number of processors.      #  ensure that enough tiles per proc (nSx,nSy) remain for the given
572        #     number of threads (nTx,nTy) ;
573        #  return the effective number of processors.
574    
575      inp=$1      inp=$1
576      out=$2      out=$2
577      np=$3      np=$3
578      dirX=$4      tx=$4
579        ty=$5
580      tmp=TTT.$$      tmp=TTT.$$
581    
582        # dirX : select with direction to favor in MPI process repartition
583        #   dirX=1 : prefer to put more proc in X direction
584        #   dirX=0 : prefer to put more proc in Y direction
585        dirX=0
586    
587      px=`grep "^     & *nPx *=" $inp | sed "s/^     & *nPx *= *//" | sed 's/, *$//'`      px=`grep "^     & *nPx *=" $inp | sed "s/^     & *nPx *= *//" | sed 's/, *$//'`
588      py=`grep "^     & *nPy *=" $inp | sed "s/^     & *nPy *= *//" | sed 's/, *$//'`      py=`grep "^     & *nPy *=" $inp | sed "s/^     & *nPy *= *//" | sed 's/, *$//'`
589      sx=`grep "^     & *nSx *=" $inp | sed "s/^     & *nSx *= *//" | sed 's/, *$//'`      sx=`grep "^     & *nSx *=" $inp | sed "s/^     & *nSx *= *//" | sed 's/, *$//'`
590      sy=`grep "^     & *nSy *=" $inp | sed "s/^     & *nSy *= *//" | sed 's/, *$//'`      sy=`grep "^     & *nSy *=" $inp | sed "s/^     & *nSy *= *//" | sed 's/, *$//'`
591    
592        #- for each direction, assume # of threads is a multiple of total number of tiles
593        nx=$px
594        if [ `expr $sx % $tx` -ne 0 -a `expr $sx \* $px % $tx` -eq 0 ] ; then
595            nx=`expr $sx \* $px / $tx`
596            if [ $verbose -gt 1 ]; then
597                echo " change px from $px to $nx to accommodate $tx threads"
598            fi
599        fi
600        ny=$py
601        if [ `expr $sy % $ty` -ne 0 -a `expr $sy \* $py % $ty` -eq 0 ] ; then
602            ny=`expr $sy \* $py / $ty`
603            if [ $verbose -gt 1 ]; then
604                echo " change py from $py to $ny to accommodate $ty threads"
605            fi
606        fi
607      #- find the largest divisor of input_file proc Nb, but not larger than $np      #- find the largest divisor of input_file proc Nb, but not larger than $np
608      pp=0      pp=0
609      i=1      i=1
610      while [ $i -le $px ] ; do      while [ $i -le $nx ] ; do
611        if [ `expr $px % $i` -eq 0 ] ; then        if [ `expr $nx % $i` -eq 0 ] ; then
612          j=1          j=1
613          while [ $j -le $py ] ; do          while [ $j -le $ny ] ; do
614            if [ `expr $py % $j` -eq 0 ] ; then            if [ `expr $ny % $j` -eq 0 ] ; then
615              ij=`expr $i \* $j`              ij=`expr $i \* $j`
616              if [ $ij -gt $pp ] ; then              if [ $ij -gt $pp ] ; then
617                  flag=1                  flag=1
# Line 631  linkdata() Line 704  linkdata()
704          (          (
705              cd $1 ; shift              cd $1 ; shift
706              echo 'linkdata from dirs:' $*              echo 'linkdata from dirs:' $*
707              inpMPI=`(cd ../$1 ; find . -name "*.mpi" -print | sed 's:^\./::')`              inpMPI=`(cd ../$1 ; find . -name "*.mpi" -print | sed 's:^\./::')`
708              for xx in $inpMPI ; do              for xx in $inpMPI ; do
709                if test -r "../"$1"/"$xx ; then                if test -r "../"$1"/"$xx ; then
710                  # found 1 _mpi sfx file in 1rst input dir and it is readable                  # found 1 _mpi sfx file in 1rst input dir and it is readable
711                  yy=`echo $xx | sed 's:\.mpi$::'`                  yy=`echo $xx | sed 's:\.mpi$::'`
712                  if test "x$MPI" = "x0" ; then                  if test "x$MPI" = "x0" ; then
713                      # not mpi test: remove symbolic link                      # not mpi test: remove symbolic link
# Line 666  linkdata() Line 739  linkdata()
739              prevDir='NONE'              prevDir='NONE'
740              for ldir in $* ; do              for ldir in $* ; do
741                  if test -d "../"$ldir -a $ldir != $prevDir ; then                  if test -d "../"$ldir -a $ldir != $prevDir ; then
742                      printf " ldir=${ldir}:" 1>&2                      printf " ldir=${ldir}:" 1>&2
743                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`                      files=`( cd "../"$ldir ; ls -1 | grep -v CVS )`
744                      for i in $files ; do                      for i in $files ; do
745                          if test ! -d "../"$ldir/$i ; then                          if test ! -d "../"$ldir/$i ; then
# Line 714  runmodel() Line 787  runmodel()
787            else rm -f $EXECUTABLE            else rm -f $EXECUTABLE
788            fi            fi
789          fi          fi
790          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then          if test ! -x $EXECUTABLE -a -x "../"$builddir"/"$EXECUTABLE ; then
791              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp              echo " link" $EXECUTABLE "from dir ../"$builddir > run.log_tmp
792              ln -sf "../"$builddir"/"$EXECUTABLE .              ln -sf "../"$builddir"/"$EXECUTABLE .
793          fi          fi
794          if test ! -x $EXECUTABLE ; then          if test ! -x $EXECUTABLE ; then
795              rm -f $RUNLOG ; touch $RUNLOG              rm -f $RUNLOG ; touch $RUNLOG
796              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
797              echo " no executable:" $EXECUTABLE >> $RUNLOG              echo " no executable:" $EXECUTABLE >> $RUNLOG
798              RETVAL=8              RETVAL=8
799              ENDVAL=-1              ENDVAL=-1
800          else          else
801            if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then            if test ! -f $OUTPUTFILE -o $OUTPUTFILE -ot $EXECUTABLE ; then
802              # output do not exist or is older than executable:              # output do not exist or is older than executable:
803              rm -f $OUTPUTFILE $RUNLOG ; touch $RUNLOG              rm -f $OUTPUTFILE $RUNLOG ; touch $RUNLOG
804              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
805            #- Divided Adjoint Run:
806            #  get the number of additional runs (add_DIVA_runs) from file "run_ADM_DIVA"
807                if test $KIND = 2 -a -f run_ADM_DIVA ; then
808                  adm_diva_nb=`sed -n '/^ *add_DIVA_runs\>.*=/p' run_ADM_DIVA | sed 's/ //g'`
809                  echo " Divided Adjoint Run: $adm_diva_nb" >> $RUNLOG
810                  eval "let $adm_diva_nb"
811                  if [ $add_DIVA_runs -ge 1 ] ; then
812                    rm -f costf* divided.ctrl snapshot*
813                    echo -n "(add_DIVA_runs=$add_DIVA_runs) ... "
814                    for ii in `seq 1 $add_DIVA_runs` ; do
815                      ( eval $COMMAND ) >> $RUNLOG 2>&1
816                      echo " additional DIVA run # $ii : done" >> $RUNLOG
817                      mv -f $OUTPUTFILE ${OUTPUTFILE}.diva_${ii}
818                    done
819                  fi
820                fi
821            #- special DIVA processing ends here
822              ( eval $COMMAND ) >> $RUNLOG 2>&1              ( eval $COMMAND ) >> $RUNLOG 2>&1
823              RETVAL=$?              RETVAL=$?
824              ENDVAL=`tail $OUTPUTFILE | grep -c 'PROGRAM MAIN: Execution ended Normally'`              ENDVAL=`tail $OUTPUTFILE | grep -c 'PROGRAM MAIN: Execution ended Normally'`
# Line 742  runmodel() Line 832  runmodel()
832              ENDVAL=`tail $OUTPUTFILE | grep -c 'PROGRAM MAIN: Execution ended Normally'`              ENDVAL=`tail $OUTPUTFILE | grep -c 'PROGRAM MAIN: Execution ended Normally'`
833              touch $RUNLOG              touch $RUNLOG
834              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi              if test -f run.log_tmp ; then cat run.log_tmp >> $RUNLOG ; fi
835              echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1              echo "---------->> $OUTPUTFILE is up to date " >> $RUNLOG 2>&1
836            fi            fi
837          fi          fi
838          rm -f run.log_tmp          rm -f run.log_tmp
839          #- in all cases where OutputFile exists, report SIZE (and AD time)          #- in all cases where OutputFile exists, report SIZE and time
840          if test -f $OUTPUTFILE ; then          if test -f $OUTPUTFILE ; then
841            grep '(PID\.TID 0000\.0001)      n.. =' $OUTPUTFILE \            grep '(PID\.TID 0000\.0001)      n.. =' $OUTPUTFILE \
842                  | sed 's/(PID.TID 0000.0001)     //' >> $CDIR"/summary.txt"                  | sed 's/(PID.TID 0000.0001)   //' >> $CDIR"/summary.txt"
843            if test "x$ADM" = xt ; then            grep -A3 'Seconds in section "ALL' $OUTPUTFILE \
844              grep -A3 'Seconds in section "ALL' $OUTPUTFILE >> $CDIR"/summary.txt"                  | sed 's/(PID.TID 0000.0001)   //' >> $CDIR"/summary.txt"
           fi  
845          fi          fi
846          if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi          if test -s STDERR.0000 ; then cp STDERR.0000 $CDIR"/STDERR.0000" ; fi
847          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then          if [ $RETVAL -eq 0 -a $ENDVAL -gt 0 ] ; then
# Line 854  formatresults() Line 943  formatresults()
943          fi          fi
944      fi      fi
945      printf '  %s' $nm      printf '  %s' $nm
946        if test $KIND = 2 ; then
947            #-- apppend taf repport summary:
948            tafrep=`grep -c '^ TAF reports ' $CDIR/summary.txt`
949            if test $tafrep = 1 ; then
950                grep '^ TAF reports ' $CDIR/summary.txt | awk '{printf "  (e=%i, w=%i)",$3,$6}'
951            fi
952        fi
953      printf '\n'      printf '\n'
954    
955  }  }
# Line 862  scandirs() Line 958  scandirs()
958  {  {
959      if [ $# -eq 1 ]; then      if [ $# -eq 1 ]; then
960          for arg in * ; do          for arg in * ; do
961              test -f $arg/$1 && echo $arg             #test -f $arg/$1 && echo $arg
962                test -f $arg/$1 -o -f $arg/$1.gz && echo $arg
963          done          done
964      else      else
965          echo $*          echo $*
# Line 918  debug=0 Line 1015  debug=0
1015  verbose=1  verbose=1
1016  NBLINES_MKLOG=16000  NBLINES_MKLOG=16000
1017    
1018  IEEE=true  OptLev=1
 if test "x$MITGCM_IEEE" != x ; then  
     IEEE=$MITGCM_IEEE  
 fi  
1019  GSL=f  GSL=f
1020    
1021  CLEANUP=f  CLEANUP=f
# Line 941  SKIPDIRS= Line 1035  SKIPDIRS=
1035  MPACKDIR="../tools/mpack-1.6"  MPACKDIR="../tools/mpack-1.6"
1036  HAVE_MPACK=  HAVE_MPACK=
1037  MPACK=  MPACK=
1038    SENDCMD=
1039    SAVDIR='.'
1040  COMMAND=  COMMAND=
1041  MKDEPEND=  MKDEPEND=
1042  if test "x$MAKE" = x ; then  if test "x$MAKE" = x ; then
1043      MAKE=make      MAKE=make
1044  fi  fi
1045    REPLMAKE=
1046  if test "x$CC" = x ; then  if test "x$CC" = x ; then
1047      CC=cc      CC=cc
1048  fi  fi
1049  JOBS=  JOBS=
1050    TARG=
1051  MPI=0  MPI=0
1052  MPI_MFILE=  MPI_MFILE=
1053  MULTI_THREAD=f  MULTI_THREAD=f
1054  OUTDIR=  OUTDIR=
1055  DELDIR=  DELDIR=
1056  USE_R4=  USE_R4=
1057    EXTRFLG=
1058    
1059  ADM=  #- type of testing (KIND):
1060  OADM=  #   KIND=0 : forward (= default) ;  KIND=1 : Tangent Linear with TAF ;
1061    #   KIND=2 : Adjoint with TAF ;     KIND=4 : Adjoint with OpenAD
1062    KIND=0
1063    
1064  # list of pTracers to check for monitor output  # list of pTracers to check for monitor output
1065  PTRACERS_NUM="1 2 3 4 5"  PTRACERS_NUM="1 2 3 4 5"
# Line 991  for ac_option ; do Line 1092  for ac_option ; do
1092          -mpackdir | --mpackdir | -mpd | --mpd) ac_prev=MPACKDIR ;;          -mpackdir | --mpackdir | -mpd | --mpd) ac_prev=MPACKDIR ;;
1093          -mpackdir=* | --mpackdir=* | -mpd=* | --mpd=*) MPACKDIR=$ac_optarg ;;          -mpackdir=* | --mpackdir=* | -mpd=* | --mpd=*) MPACKDIR=$ac_optarg ;;
1094    
1095            -send | --send ) ac_prev=SENDCMD ;;
1096            -send=* | --send=* ) SENDCMD=$ac_optarg ;;
1097            -savdir | --savdir | -sd | --sd ) ac_prev=SAVDIR ;;
1098            -savdir=* | --savdir=* | -sd=* | --sd=* ) SAVDIR=$ac_optarg ;;
1099    
1100          -tdir | --tdir | -t | --t) ac_prev=TESTDIRS ;;          -tdir | --tdir | -t | --t) ac_prev=TESTDIRS ;;
1101          -tdir=* | --tdir=* | -t=* | --t=*) TESTDIRS=$ac_optarg ;;          -tdir=* | --tdir=* | -t=* | --t=*) TESTDIRS=$ac_optarg ;;
1102          -skipdir | --skipdir | -skd | --skd) ac_prev=SKIPDIRS ;;          -skipdir | --skipdir | -skd | --skd) ac_prev=SKIPDIRS ;;
# Line 1008  for ac_option ; do Line 1114  for ac_option ; do
1114          -make | --make | -m | --m) ac_prev=MAKE ;;          -make | --make | -m | --m) ac_prev=MAKE ;;
1115          -make=* | --make=* | -m=* | --m=*) MAKE=$ac_optarg ;;          -make=* | --make=* | -m=* | --m=*) MAKE=$ac_optarg ;;
1116    
1117            -repl_mk | --repl_mk ) ac_prev=REPLMAKE ;;
1118            -repl_mk=* | --repl_mk=*) REPLMAKE=$ac_optarg ;;
1119    
1120          -odir | --odir) ac_prev=OUTDIR ;;          -odir | --odir) ac_prev=OUTDIR ;;
1121          -odir=* | --odir=*) OUTDIR=$ac_optarg ;;          -odir=* | --odir=*) OUTDIR=$ac_optarg ;;
1122    
# Line 1020  for ac_option ; do Line 1129  for ac_option ; do
1129          -j | --j) ac_prev=JOBS ;;          -j | --j) ac_prev=JOBS ;;
1130          -j=* | --j=*) JOBS=$ac_optarg ;;          -j=* | --j=*) JOBS=$ac_optarg ;;
1131    
1132            -ef | --ef) ac_prev=EXTRFLG ;;
1133            -ef=* | --ef=*) EXTRFLG=$ac_optarg ;;
1134    
1135          -clean | --clean) CLEANUP=t ; DELDIR=t ;;          -clean | --clean) CLEANUP=t ; DELDIR=t ;;
1136    
1137          -norun | --norun | -nr | --nr) NORUN=t ;;          -norun | --norun | -nr | --nr) NORUN=t ;;
1138            -obj | --obj ) TARG='obj' ; NORUN=t ;;
1139          -runonly | --runonly | -ro | --ro) QUICK=t ; NOMAKE=t ;;          -runonly | --runonly | -ro | --ro) QUICK=t ; NOMAKE=t ;;
1140          -quick | --quick | -q | --q) QUICK=t ;;          -quick | --quick | -q | --q) QUICK=t ;;
1141          -nogenmake | --nogenmake | -ng | --ng) NOGENMAKE=t ;;          -nogenmake | --nogenmake | -ng | --ng) NOGENMAKE=t ;;
# Line 1041  for ac_option ; do Line 1154  for ac_option ; do
1154    
1155          -mth) MULTI_THREAD=t ;;          -mth) MULTI_THREAD=t ;;
1156    
1157          -adm | -ad) ADM=t ;;          -tlm) if test $KIND = 0 ; then KIND=1 ; else
1158          -oad) OADM=t; NODEPEND=t ;;                  echo "Error: '-tlm', '-adm' and '-oad' are exclusive" ; usage
1159                  fi ;;
1160          -ieee) IEEE=true ;;          -adm | -ad) if test $KIND = 0 ; then KIND=2 ; else
1161          -noieee) IEEE= ;;                  echo "Error: '-tlm', '-adm' and '-oad' are exclusive" ; usage
1162                  fi ;;
1163            -oad) if test $KIND = 0 ; then KIND=4 ; NODEPEND=t ; else
1164                    echo "Error: '-tlm', '-adm' and '-oad' are exclusive" ; usage
1165                  fi ;;
1166    
1167            -ieee)   echo "Warning: ignore option '-ieee' (already the default)"
1168                     printf " ... " ;;
1169            -noieee) echo "Warning: will use option '-fast' instead of '-noieee' (obsolete)"
1170                     printf " ... " ; OptLev=`expr $OptLev \* 2` ;;
1171            -fast)  OptLev=`expr $OptLev \* 2` ;;
1172            -devel) OptLev=0 ;;
1173          -gsl) GSL=t ;;          -gsl) GSL=t ;;
1174    
1175          -verbose) verbose=2 ;;          -verbose) verbose=2 ;;
# Line 1080  if test "x$MPI" != x0 -a "x$MPI_MFILE" ! Line 1204  if test "x$MPI" != x0 -a "x$MPI_MFILE" !
1204      if test -r $MPI_MFILE ; then      if test -r $MPI_MFILE ; then
1205          nl=`wc -l $MPI_MFILE | awk '{print $1}'`          nl=`wc -l $MPI_MFILE | awk '{print $1}'`
1206          if [ $nl -lt $MPI ] ; then          if [ $nl -lt $MPI ] ; then
1207            echo "Error: need at least $MPI nodes (currently only $nl) in MPI_MFILE=$MPI_FILE"            echo "Error: need at least $MPI nodes (currently only $nl) in MPI_MFILE=$MPI_FILE"
1208            usage            usage
1209          fi          fi
1210          if [ $verbose -gt 1 ]; then          if [ $verbose -gt 1 ]; then
1211              echo " MPI_MFILE=$MPI_MFILE : $nl procs for MPI=$MPI run"              echo " MPI_MFILE=$MPI_MFILE : $nl procs for MPI=$MPI run"
1212          fi          fi
1213      else      else
1214            echo "Error: cannot access MPI_MFILE=$MPI_FILE"            echo "Error: cannot access MPI_MFILE=$MPI_FILE"
1215            usage            usage
1216      fi      fi
1217  fi  fi
1218    
1219  #- setting for forward or ADM testing  #- setting for forward or ADM testing
1220  if test "x$ADM" = xt ; then  if test $KIND = 1 ; then
1221        TARG=ftlall
1222        code_dir=code_ad
1223        inputdir=input_ad
1224        ref_outp="output_tlm.txt"
1225        EXECUTABLE="mitgcmuv_ftl"
1226    elif test $KIND = 2 ; then
1227        if test "x$TARG" = xobj ; then TARG=adobj ; else TARG=adall ; fi
1228      code_dir=code_ad      code_dir=code_ad
1229      inputdir=input_ad      inputdir=input_ad
1230      ref_outp="output_adm.txt"      ref_outp="output_adm.txt"
1231      EXECUTABLE="mitgcmuv_ad"      EXECUTABLE="mitgcmuv_ad"
1232  elif test "x$OADM" = xt ; then  elif test $KIND = 4 ; then
1233        TARG=adAll
1234      code_dir=code_oad      code_dir=code_oad
1235      inputdir=input_oad      inputdir=input_oad
1236      ref_outp="output_oadm.txt"      ref_outp="output_oadm.txt"
1237      EXECUTABLE="mitgcmuv_ad"      EXECUTABLE="mitgcmuv_ad"
1238  else  else
1239        if test "x$JOBS" != x ; then TARG="-j $JOBS $TARG" ; fi
1240      code_dir=code      code_dir=code
1241      inputdir=input      inputdir=input
1242      ref_outp="output.txt"      ref_outp="output.txt"
# Line 1147  do Line 1280  do
1280              echo ""; echo -n " -- skip \"$xx\" (not a directory !)"              echo ""; echo -n " -- skip \"$xx\" (not a directory !)"
1281          fi          fi
1282      else      else
1283          if test $count = 1 ; then echo -n ", \"$xx\""          if test $count = 1 ; then echo -n ", \"$xx\""
1284          else count=1 ; echo "" ;  echo -n " skip: \"$xx\""          else count=1 ; echo "" ;  echo -n " skip: \"$xx\""
1285          fi          fi
1286      fi      fi
# Line 1161  fi Line 1294  fi
1294    
1295  LOC_MFILE='tr_mpi_mfile'  LOC_MFILE='tr_mpi_mfile'
1296  RUNLOG="run.tr_log"  RUNLOG="run.tr_log"
1297  OUTPUTFILE=$ref_outp  if test "x$MPI" = x0 ; then
1298  if test "x$COMMAND" = x ; then    OUTPUTFILE=$ref_outp
1299      COMMAND="./$EXECUTABLE > $OUTPUTFILE"    if test "x$COMMAND" = x ; then COMMAND="./$EXECUTABLE > $OUTPUTFILE" ; fi
1300  fi  else
1301  if test "x$MPI" != x0 ; then    OUTPUTFILE="STDOUT.0000"
1302      OUTPUTFILE="STDOUT.0000"    if test "x$COMMAND" = x ; then COMMAND="mpirun -v -np TR_NPROC ./$EXECUTABLE" ; fi
1303  fi  fi
1304    
1305  echo "OK (COMMAND= $COMMAND )"  echo "OK (COMMAND='$COMMAND')"
1306    
1307    TMP=./tr_$$
1308    #- try to put temporary files in system-local /tmp dir
1309    #TMP=/tmp/tr_$$
1310    #touch $TMP ; retVal=$?
1311    #if [ $retVal -eq 0 ] ; then
1312    #  if test ! -r $TMP ; then TMP=./tr_$$ ; fi
1313    #else
1314    #  TMP=./tr_$$
1315    #fi
1316    #rm -f $TMP
1317    #if [ $verbose -gt 1 ]; then echo " temp files: $TMP" ; fi
1318    
1319  # set the Default List of output variables to be checked:  # set the Default List of output variables to be checked:
1320  #  (use default or load experiment-specific list from file "tr_checklist")  #  (use default or load experiment-specific list from file "tr_checklist")
1321  # content : 1rst = main variable used to decide if it pass or FAIL  # content : 1rst = main variable used to decide if it pass or FAIL
1322  #         others = number of matching digits to be printed in summary.txt  #         others = number of matching digits to be printed in summary.txt
1323  if test "x$ADM" = x -a "x$OADM" = x; then  if test $KIND = 1 ; then
1324        DEF_CHECK_LIST='tlmGrd tlmCst tlmGrd fwdGrd'
1325        EMPTY_RESULTS='.. .. ..'
1326        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1327    elif test $KIND = 2 -o $KIND = 4 ; then
1328        DEF_CHECK_LIST='AdGrd Cost AdGrd FDGrd'
1329        EMPTY_RESULTS='.. .. ..'
1330        LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1331    else
1332      DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'      DEF_CHECK_LIST='PS PS T+ S+ U+ V+ pt1+ pt2+ pt3+ pt4+ pt5+'
1333      EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'      EMPTY_RESULTS='.. .. .. .. .. .. .. .. .. .. .. .. .. .. .. .. ..'
1334      LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`      LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`
1335      ii=`echo $EMPTY_RESULTS | awk '{print NF}'`      ii=`echo $EMPTY_RESULTS | awk '{print NF}'`
1336      EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`      EMPTY_RESULTS=$EMPTY_RESULTS`expr $LEN_CHECK_LIST - $ii | awk 'BEGIN{FS=":"}{for(i=1;i<=$1;i++){printf "  ."}}'`
 else  
     DEF_CHECK_LIST='Grad Cost Grad'  
     EMPTY_RESULTS='.. ..'  
     LEN_CHECK_LIST=`echo $DEF_CHECK_LIST | sed 's/ [a-zA-Z0-9]*+/&mn &mx &av &sd/g' | awk '{print NF-1}'`  
1337  fi  fi
1338    
1339  #  create the FORTRAN comparison code  #  create the FORTRAN comparison code
1340  if test -x tr_cmpnum ; then  if test "x$CLEANUP" = xt -o -x tr_cmpnum ; then
1341      echo "skipping comparison code build"      echo "skipping comparison code build"
1342  else  else
1343      createcodelet      createcodelet
1344  fi  fi
1345    
1346  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)  #  build the mpack utility (if ADDRESSES = NONE, do it to test the build)
1347  if test "x$ADDRESSES" = x ; then  if test "x$ADDRESSES" = x -o "x$SENDCMD" != x ; then
1348      echo "skipping mpack build"      echo "skipping mpack build"
1349  else  else
1350      build_mpack      build_mpack
1351        if test "x$HAVE_MPACK" = xt ; then SENDCMD=$MPACK ; fi
1352  fi  fi
1353    
1354  #  Create a uniquely named directory to store results  #  Create a uniquely named directory to store results
1355  CMDLINE=$0  CMDLINE=$0
1356  for xx in "$@" ; do nw=`echo $xx | wc -w`  for xx in "$@" ; do nw=`echo $xx | wc -w`
1357      if test $nw = '1' ; then CMDLINE="$CMDLINE $xx"      if test $nw = '1' ; then CMDLINE="$CMDLINE $xx" ; else
1358                          else CMDLINE="$CMDLINE '$xx'" ; fi        nb=`echo $xx | grep -c '='`
1359          if test $nb = 0 ; then CMDLINE="$CMDLINE '$xx'"
1360          else yy=`echo "$xx'" | sed "s/=/='/"` ;
1361                                 CMDLINE="$CMDLINE $yy" ; fi
1362        fi
1363  done  done
1364  #for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done  #for xx in "$@" ; do CMDLINE="$CMDLINE '$xx'" ; done
1365  MACH=`hostname`  MACH=`hostname`
# Line 1252  if test "x$OPTFILE" != xNONE ; then Line 1406  if test "x$OPTFILE" != xNONE ; then
1406          echo >> $SUMMARY          echo >> $SUMMARY
1407          echo "  OPTFILE=$OPTFILE" >> $SUMMARY          echo "  OPTFILE=$OPTFILE" >> $SUMMARY
1408      else      else
1409          echo | tee $SUMMARY          echo | tee -a $SUMMARY
1410          echo "ERROR: can't read OPTFILE=\"$OPTFILE\"" | tee $SUMMARY          echo "ERROR: can't read OPTFILE=\"$OPTFILE\"" | tee -a $SUMMARY
1411          exit 1          exit 1
1412      fi      fi
1413  else  else
# Line 1263  else Line 1417  else
1417  fi  fi
1418  echo  echo
1419  echo >> $SUMMARY  echo >> $SUMMARY
1420  if test "x$ADM" = x -a "x$OADM" = x; then  if test $KIND = 0 ; then
1421      if [ $MATCH_CRIT -lt 10 ] ;      line_0=`printf '%s %2i' 'default' $MATCH_CRIT`
     then line_0="default  "$MATCH_CRIT ;  
     else line_0="default "$MATCH_CRIT ; fi  
1422         line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"         line_0="$line_0  ----T-----  ----S-----  ----U-----  ----V-----"
1423      line_1="G D M    c        m  s        m  s        m  s        m  s"      line_1="G D M    c        m  s        m  s        m  s        m  s"
1424      line_2="E p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."      line_2="e p a R  g  m  m  e  .  m  m  e  .  m  m  e  .  m  m  e  ."
1425      line_3="N n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"      line_3="n n k u  2  i  a  a  d  i  a  a  d  i  a  a  d  i  a  a  d"
1426      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."      line_4="2 d e n  d  n  x  n  .  n  x  n  .  n  x  n  .  n  x  n  ."
1427      for ii in $PTRACERS_NUM ; do      for ii in $PTRACERS_NUM ; do
1428          line_0="$line_0  --PTR 0"$ii"--"          line_0="$line_0  --PTR 0"$ii"--"
# Line 1279  if test "x$ADM" = x -a "x$OADM" = x; the Line 1431  if test "x$ADM" = x -a "x$OADM" = x; the
1431          line_3="$line_3  i  a  a  d"          line_3="$line_3  i  a  a  d"
1432          line_4="$line_4  n  x  n  ."          line_4="$line_4  n  x  n  ."
1433      done      done
1434    else
1435        line_0=`printf '%s %2i' 'default   ' $MATCH_CRIT`
1436      if test $KIND = 1 ; then
1437       #echo "TANGLIN=true" >> $SUMMARY
1438        echo "TangLin generated by TAF" >> $SUMMARY
1439      elif test $KIND = 3 ; then
1440        echo "TangLin generated by OpenAD" >> $SUMMARY
1441      elif test $KIND = 2 ; then
1442       #echo "ADJOINT=true" >> $SUMMARY
1443        echo "Adjoint generated by TAF" >> $SUMMARY
1444      else
1445        echo "Adjoint generated by OpenAD" >> $SUMMARY
1446      fi
1447      if test $KIND = 1 -o $KIND = 3 ; then
1448        line_1="G D M    C  T  F"
1449        line_2="e p a R  o  L  D"
1450      else
1451        line_1="G D M    C  A  F"
1452        line_2="e p a R  o  d  D"
1453      fi
1454        line_3="n n k u  s  G  G"
1455        line_4="2 d e n  t  r  r"
1456        echo >> $SUMMARY
1457    fi
1458    if test "x$CLEANUP" != xt ; then
1459      echo "$line_0" | tee -a $SUMMARY      echo "$line_0" | tee -a $SUMMARY
1460      echo "$line_1" | tee -a $SUMMARY      echo "$line_1" | tee -a $SUMMARY
1461      echo "$line_2" | tee -a $SUMMARY      echo "$line_2" | tee -a $SUMMARY
1462      echo "$line_3" | tee -a $SUMMARY      echo "$line_3" | tee -a $SUMMARY
1463      echo "$line_4" | tee -a $SUMMARY      echo "$line_4" | tee -a $SUMMARY
1464      echo " "       | tee -a $SUMMARY      echo ""        | tee -a $SUMMARY
 else  
     echo "ADJOINT=true" >> $SUMMARY  
     echo >> $SUMMARY  
     if [ $MATCH_CRIT -lt 10 ] ;  
     then line_0="default     "$MATCH_CRIT ;  
     else line_0="default    "$MATCH_CRIT ; fi  
     echo "$line_0" | tee -a $SUMMARY  
     cat << EOF | tee -a $SUMMARY  
 G D M    C  G  
 E p a R  o  r  
 N n k u  s  a  
 2 d e n  t  d  
   
 EOF  
1465  fi  fi
1466  echo "-------------------------------------------------------------------------------"  echo "-------------------------------------------------------------------------------"
1467    
# Line 1324  for dir in $TESTDIRS ; do Line 1487  for dir in $TESTDIRS ; do
1487              rm -f $EXECUTABLE *.bak              rm -f $EXECUTABLE *.bak
1488              rm -f genmake_state genmake_*optfile genmake.log              rm -f genmake_state genmake_*optfile genmake.log
1489              rm -f SIZE.h.mpi genmake.tr_log make.tr_log              rm -f SIZE.h.mpi genmake.tr_log make.tr_log
1490                rm -rf mpi_headers
1491          )          )
1492          if test -d $dir/$rundir/CVS ; then          if test -d $dir/$rundir/CVS ; then
1493              echo -n '  --- dir:' $dir/$rundir ': '              echo -n '  --- dir:' $dir/$rundir ': '
1494              run_clean $dir/$rundir              run_clean $dir/$rundir
1495          fi          fi
1496          trdir=`( cd $dir ; find . -type d -name "$pfxdir.*" -print | sed 's/^.\///')`          trdir=`( cd $dir ; find . -type d -name "$pfxdir.*" -print | sed 's/^.\///')`
# Line 1341  for dir in $TESTDIRS ; do Line 1505  for dir in $TESTDIRS ; do
1505      #  Verify that the testdir exists and contains previous      #  Verify that the testdir exists and contains previous
1506      #  results in the correct location--or skip this directory!      #  results in the correct location--or skip this directory!
1507      fout=$dir"/results/"$ref_outp      fout=$dir"/results/"$ref_outp
1508      if test ! -r $fout ; then     #if test ! -r $fout ; then
1509        if test ! -r $fout -a ! -r ${fout}.gz ; then
1510          echo "can't read \"$fout\" -- skipping $dir"          echo "can't read \"$fout\" -- skipping $dir"
1511          continue          continue
1512      fi      fi
# Line 1358  for dir in $TESTDIRS ; do Line 1523  for dir in $TESTDIRS ; do
1523      fi      fi
1524    
1525      if test "x$MPI" != "x0" ; then      if test "x$MPI" != "x0" ; then
1526          prefer_X=0          ntx=1 ; nty=1
1527          if test "x$MULTI_THREAD" = "xt" ; then          if test "x$MULTI_THREAD" = "xt" ; then
1528              retv=`check_eedata $dir"/input/eedata.mth"`            ff=$dir"/input/eedata.mth"
1529              if test $retv = 1 ; then prefer_X=1 ; fi            ntx=`grep "^ *nTx *=" $ff | tail -1 | sed 's/^ *nTx *= *//' | sed "s/, *$//"`
1530              nty=`grep "^ *nTy *=" $ff | tail -1 | sed 's/^ *nTy *= *//' | sed "s/, *$//"`
1531              if test "x$ntx" = x ; then ntx=1 ; fi
1532              if test "x$nty" = x ; then nty=1 ; fi
1533          fi          fi
1534          #- create new SIZE.h with no more than '$MPI' Procs          #- create new SIZE.h with no more than '$MPI' Procs
1535          mk_mpi_size $CODE_DIR"/SIZE.h_mpi" $BUILD_DIR"/tr_size.mpi" $MPI $prefer_X          mk_mpi_size $CODE_DIR"/SIZE.h_mpi" $BUILD_DIR"/tr_size.mpi" $MPI $ntx $nty
1536          LOC_NPROC=$?          LOC_NPROC=$?
1537          (   cd $BUILD_DIR          (   cd $BUILD_DIR
1538              if test -r SIZE.h.mpi ; then              if test -r SIZE.h.mpi ; then
# Line 1404  for dir in $TESTDIRS ; do Line 1572  for dir in $TESTDIRS ; do
1572      #  Check whether there are "extra runs" for this testdir      #  Check whether there are "extra runs" for this testdir
1573      extra_runs=      extra_runs=
1574      if test "x$NORUN" = xf ; then      if test "x$NORUN" = xf ; then
1575          ex_run_dirs=`( cd $dir ; echo $inputdir.* )`          ex_run_dirs=`( cd $dir ; ls -d $inputdir.* 2> /dev/null )`
1576      fi      fi
1577      #echo "ex_run_dirs='$ex_run_dirs'"      #echo "ex_run_dirs='$ex_run_dirs'"
1578      for exd in $ex_run_dirs ; do      for exd in $ex_run_dirs ; do
1579          name=`echo $exd | sed -e "s/$inputdir\.//"`          name=`echo $exd | sed -e "s/$inputdir\.//"`
1580          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`          refExOut=`echo $ref_outp | sed "s/\./.${name}./"`
1581          outf="$dir/results/$refExOut"          outf="$dir/results/$refExOut"
1582          if test -f $outf -a -r $outf ; then          if test -r $outf -o -r ${outf}.gz ; then
1583            if test "x$MULTI_THREAD" = "xt" ; then            if test "x$MULTI_THREAD" = "xt" ; then
1584              if test -r $dir"/"$exd"/eedata.mth" ; then              if test -r $dir"/"$exd"/eedata.mth" ; then
1585                if test "x$MPI" = "x0" ; then                if test "x$MPI" = "x0" ; then
# Line 1434  for dir in $TESTDIRS ; do Line 1602  for dir in $TESTDIRS ; do
1602    
1603      echo      echo
1604      if test "x$extra_runs" = "x" ; then      if test "x$extra_runs" = "x" ; then
1605         echo "Experiment:  $dir"          echo "Experiment:  $dir"
1606      else      else
1607         echo "Experiment:  $dir ; extra_runs=$extra_runs"          echo "Experiment:  $dir ; extra_runs=$extra_runs"
1608      fi      fi
1609      echo      echo
1610      unset genmake makedepend make run      unset genmake makedepend make run
# Line 1455  for dir in $TESTDIRS ; do Line 1623  for dir in $TESTDIRS ; do
1623              run=N              run=N
1624          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
1625              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
1626              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1627              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1628              && makemodel $dir/$builddir && make=Y              && makemodel $dir/$builddir && make=Y
1629      else      else
1630          genmakemodel $dir/$builddir && genmake=Y \          genmakemodel $dir/$builddir && genmake=Y \
1631              && makeclean $dir/$builddir \              && makeclean $dir/$builddir \
1632              && symlink_mpifiles $dir $code_dir $builddir \              && symlink_mpifiles $dir $code_dir $builddir \
1633              && makedependmodel $dir/$builddir && makedepend=Y \              && makedependmodel $dir/$builddir && makedepend=Y \
1634              && makemodel $dir/$builddir && make=Y \              && makemodel $dir/$builddir && make=Y \
1635              && run_clean $dir/$rundir \              && run_clean $dir/$rundir \
# Line 1473  for dir in $TESTDIRS ; do Line 1641  for dir in $TESTDIRS ; do
1641    
1642          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`          fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
1643          echo 1>&2          echo 1>&2
1644          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY          echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1645          echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $locDIR"/summary.txt"          echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $locDIR"/summary.txt"
1646    
1647          for ex in $extra_runs ; do          for ex in $extra_runs ; do
1648              unset run              unset run
1649              results=$EMPTY_RESULTS              results=$EMPTY_RESULTS
1650              #  reference output file              #  reference output file
1651              refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`              refExOut=`echo $ref_outp | sed "s/\./.${ex}./g"`
1652              #  Create an output dir & summary.txt file for each extra run (tdir.ex)              #  Create an output dir & summary.txt file for each extra run (tdir.ex)
# Line 1494  for dir in $TESTDIRS ; do Line 1662  for dir in $TESTDIRS ; do
1662              linkdata $dir/$pfxdir.$ex $inputdir.$ex $inputdir              linkdata $dir/$pfxdir.$ex $inputdir.$ex $inputdir
1663              runmodel $dir/$pfxdir.$ex && run=Y \              runmodel $dir/$pfxdir.$ex && run=Y \
1664              && results=`testoutput_run $dir $pfxdir.$ex $refExOut`              && results=`testoutput_run $dir $pfxdir.$ex $refExOut`
1665              fres=`formatresults $dir ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`              fres=`formatresults $dir.$ex ${genmake:-N} ${makedepend:-N} ${make:-N} ${run:-N} $results`
             fres="$fres.$ex"  
1666              echo 1>&2              echo 1>&2
1667              echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY              echo "$fres" | sed 's/ 99/ --/g' | sed 's/  > />/' | sed 's/  < /</' >> $SUMMARY
1668              echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $locDIR"/summary.txt"              echo "fresults='$fres'" | sed 's/ 99/ --/g' >> $locDIR"/summary.txt"
# Line 1504  for dir in $TESTDIRS ; do Line 1671  for dir in $TESTDIRS ; do
1671              fi              fi
1672          done          done
1673    
1674      if test -f $DRESULTS"/"genmake_state ; then : ; else      if test ! -f $DRESULTS"/"genmake_state ; then
1675          if test -f $dir/$builddir/Makefile ; then          if test -f $dir/$builddir/Makefile ; then
1676              mkOpt=`grep '^# OPTFILE=' $dir/$builddir/Makefile 2>/dev/null | head -1 | sed 's/^# //'`              mkOpt=`grep '^# OPTFILE=' $dir/$builddir/Makefile 2>/dev/null | head -1 | sed 's/^# //'`
1677              echo "from '$dir/$builddir/Makefile', extract:" > $DRESULTS/genmake_state              echo "from '$dir/$builddir/Makefile', extract:" > $DRESULTS/genmake_state
# Line 1513  for dir in $TESTDIRS ; do Line 1680  for dir in $TESTDIRS ; do
1680              if test "x$OPTFILE" = xNONE ; then              if test "x$OPTFILE" = xNONE ; then
1681                  eval $mkOpt                  eval $mkOpt
1682                  sed "/^No \"OPTFILE\" was specified ; genmake2/a\  OPTFILE=${OPTFILE}"\                  sed "/^No \"OPTFILE\" was specified ; genmake2/a\  OPTFILE=${OPTFILE}"\
1683                          $SUMMARY > tr_0.tmp_log                          $SUMMARY > tmp.tr_log
1684                  RETVAL=$?                  RETVAL=$?
1685                  if test "x$RETVAL" = x0 ; then rm -f $SUMMARY                  if test "x$RETVAL" = x0 ; then
1686                          cp tr_0.tmp_log $SUMMARY                      cp -f tmp.tr_log $SUMMARY
                 else rm -f tr_0.tmp_log  
1687                  fi                  fi
1688                    rm -f tmp.tr_log
1689              fi              fi
1690              gmkLog=$dir/$builddir/genmake.log              gmkLog=$dir/$builddir/genmake.log
1691              grep '^Get compiler version using:' $gmkLog > /dev/null 2>&1              if test -r $gmkLog ; then
1692              RETVAL=$?                  grep '^Get compiler version using:' $gmkLog > /dev/null 2>&1
1693              if test "x$RETVAL" = x0 ; then                  RETVAL=$?
1694                  echo "from '$gmkLog', extract compiler version:" >> $DRESULTS/genmake_state                  if test "x$RETVAL" = x0 ; then
1695                  sed -n '/Get compiler version/,/<-- compiler version/p' $gmkLog \                    echo -n "from '$gmkLog', " >> $DRESULTS/genmake_state
1696                         | grep -v '^... compiler version ' > tr_1.tmp_log                    echo "extract compiler version:"   >> $DRESULTS/genmake_state
1697                  sed -n '1,/^$/p' tr_1.tmp_log | sed '/^$/d' | sed 's/^./ &/' \                    sed -n '/Get compiler version/,/<-- compiler version/p' \
1698                          >> $DRESULTS/genmake_state                       $gmkLog | grep -v '^... compiler version ' > tmp.tr_log
1699                  rm -f tr_1.tmp_log                    sed -n '1p' tmp.tr_log >> $DRESULTS/genmake_state
1700                      sed -n '2,/^$/p' tmp.tr_log | sed '/^$/d' | sed 's/^./ &/' \
1701                                             >> $DRESULTS/genmake_state
1702                      rm -f tmp.tr_log
1703                    fi
1704                    echo -n "from '$gmkLog', " >> $DRESULTS/genmake_state
1705                    echo "get NETCDF & LAPACK settings:" >> $DRESULTS/genmake_state
1706                    sed -n '/set HAVE_NETCDF=/p' $gmkLog >> $DRESULTS/genmake_state
1707                    sed -n '/set HAVE_LAPACK=/p' $gmkLog >> $DRESULTS/genmake_state
1708              fi              fi
1709          fi          fi
1710      fi      fi
1711      #postclean $dir/$builddir      #postclean $dir/$builddir
1712      if test "x$POSTCLEAN" = x2 ; then      if test "x$POSTCLEAN" = x2 ; then
1713          makeclean $dir/$builddir \          makeclean $dir/$builddir \
1714              && run_clean $dir/$rundir              && run_clean $dir/$rundir
1715      fi      fi
1716      if test "x$MPI" != x0 -a "x$MPI_MFILE" != x ; then rm -f $LOC_MFILE ; fi      if test "x$MPI" != x0 -a "x$MPI_MFILE" != x ; then rm -f $LOC_MFILE ; fi
1717    
# Line 1554  date >> $SUMMARY Line 1729  date >> $SUMMARY
1729  if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then  if test "x$ADDRESSES" = xNONE -o "x$ADDRESSES" = x ; then
1730      echo "No results email was sent."      echo "No results email was sent."
1731  else  else
1732      if test "x$HAVE_MPACK" = xt ; then      if test "x$SENDCMD" != x ; then
1733          tar -cf $DRESULTS".tar" $DRESULTS > /dev/null 2>&1 \          if [ $verbose -gt 1 ]; then
1734              && gzip $DRESULTS".tar" \             echo " run: $SENDCMD -s MITgcm-test -m 3555000 ${SAVDIR}/${DRESULTS}".tar.gz" $ADDRESSES"
1735              && $MPACK -s MITgcm-test -m 3555000 $DRESULTS".tar.gz" $ADDRESSES          fi
1736            tar -cf ${SAVDIR}/${DRESULTS}".tar" $DRESULTS > /dev/null 2>&1 \
1737                && gzip ${SAVDIR}/${DRESULTS}".tar" \
1738                && $SENDCMD -s MITgcm-test -m 3555000 ${SAVDIR}/${DRESULTS}".tar.gz" $ADDRESSES
1739          RETVAL=$?          RETVAL=$?
1740          if test "x$RETVAL" != x0 ; then          if test "x$RETVAL" != x0 ; then
1741              echo              echo
# Line 1570  else Line 1748  else
1748              echo "An email containing results was sent to the following addresses:"              echo "An email containing results was sent to the following addresses:"
1749              echo "  \"$ADDRESSES\""              echo "  \"$ADDRESSES\""
1750              echo              echo
1751              test -f $DRESULTS".tar"  &&  rm -f $DRESULTS".tar"              test -f ${SAVDIR}/${DRESULTS}".tar" &&  rm -f ${SAVDIR}/${DRESULTS}".tar"
1752              test -f $DRESULTS".tar.gz"  &&  rm -f $DRESULTS".tar.gz"              test -f ${SAVDIR}/${DRESULTS}".tar.gz" &&  rm -f ${SAVDIR}/${DRESULTS}".tar.gz"
1753          fi          fi
1754      fi      fi
1755  fi  fi
# Line 1583  fi Line 1761  fi
1761  if test "x$CLEANUP" != xt ; then  if test "x$CLEANUP" != xt ; then
1762      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'      cat $SUMMARY | sed 's/ \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \.  \. //'
1763      if test -e tr_out.txt ; then      if test -e tr_out.txt ; then
1764          mv tr_out.txt tr_out.txt.old          mv tr_out.txt tr_out.txt.old
1765      fi      fi
1766      cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt      cat $SUMMARY | sed '/^[YN] [YN] [YN] [YN]/ s/ \. //g' > tr_out.txt
1767  fi  fi
# Line 1591  fi Line 1769  fi
1769  if test "x$DELDIR" = xt ; then  if test "x$DELDIR" = xt ; then
1770      rm -rf $DRESULTS      rm -rf $DRESULTS
1771  fi  fi
1772    echo "======== End of testreport execution ========"

Legend:
Removed from v.1.163  
changed lines
  Added in v.1.195

  ViewVC Help
Powered by ViewVC 1.1.22